-- Channel messages for pvp battles.


local WowkemonChannelPrefix = "wowkemon";
local WowkemonChannelType = "PARTY"
local WowkemonChannelMessage = WowkemonChannelPrefix
local myRealm = string.gsub(GetRealmName(), "%s+", "")
local myCharacterName = GetUnitName("player");
local registerPrefixRequest = C_ChatInfo.RegisterAddonMessagePrefix(WowkemonChannelPrefix)
--if registerPrefixRequest == true then
--  print("Successfully registered Wowkemon channel prefix.");
--else
--  print("Failed to register wowkemon channel prefix");
--end

local wowkemonChallengeTimeout = 20;  -- Time before a challenge request times out
WowkemonAwaitingChallengeResponse = false;  -- client state. Limits the challenges to 1 per timeout window
WowkemonChallengeSent = false;  --  Possibly deprecated? Review
WowkemonInBattle = false;     -- if the local client is currently in a battle
WowkemonCurrentBattleOpponent = nil; -- Who the local clients opponent is
local wowkemonOpponentReady = false  -- Opponent Ready State, Transitions from lobby to Battle when both are ready
local wowkemonPlayerReady = false; -- local client ready state
local wowkemonOpponentWowkemonInfo = {}; -- The Opponents Wowkemon Data
CurrentWowkemonHP = 0;
currentWowkemonMaxHP = 100;
currentWowkemonAP = 0;

function wowkemonResetBattleStatus(reason)  -- reset all battle variables.
  if reason =="timeout" and WowkemonInBattle == false then
      WowkemonChallengeSent = false;
      WowkemonAwaitingChallengeResponse = false;
      WowkemonInBattle = false;
      print("Challenge timed out")
  elseif reason == "NoResponse" and WowkemonInBattle == false then
  WowkemonChallengeSent = false;
  WowkemonAwaitingChallengeResponse = false;
  WowkemonInBattle = false;
  WowkemonCurrentBattleOpponent = nil;
elseif reason =="clear" then
  WowkemonChallengeSent = false;
  WowkemonAwaitingChallengeResponse = false;
  WowkemonInBattle = false;
  WowkemonCurrentBattleOpponent = nil;
  wowkemonPlayerReady = false;
  wowkemonOpponentReady = false;
  currentWowkemonAP = 0;
  wowkemonUpdateFeedbackText("",true)
end
end
-- ADDON MESSAGE DATA PREFIXES:  <WCR> - (Wowkemon challenge request) send challenge to player. structure:  <WCR>,OriginatorCharacterName,TargetCharacterName,trainerLevel
                                -- <WCRA> - (Wowkemon challenge request accepted) responds to a challenge with yes or no. structure: <WCRA>,OriginatorCharacterName,TargetCharacterName,Response
--DEPRECATED - BUNDLED WITH WBWI:   <WCI> (Wowkemon challenge initiated) Informs the opponent that you are loaded into battle: <WCI>,OriginatorCharacterName,TargetCharacterName
                                -- <WBWI> (Wowkemon battle wowkemon info) The initial state of the chosen wowkemon. Sends all relevant info, name/level/HP : <WBWI>,TargetCharacterName,WowkemonIndex,WowkemonLevel,WowkemonHP
                                -- <WBBI> (Wowkemon Battle buff info) Buff information, potions used etc.. sent when used. <WBBI>,OriginatorCharacterName,buffName
                                -- <WBA> (Wowkemon Battle Action) Attack information sent. Sends current attack data: <WBA>,OriginatorCharacterName,attackName,baseDamage
                                -- <WBAR> (Wowkemon Battle Action Result) the result of the previous attack information. sent after calculating incoming attack:  <WBAR>,OriginatorCharacterName,TargetCharacterName,FinalDamageDone,damageType(hit/crit/resist etc)
                                -- <WBFR> (Wowkemon battle forfeit request) Sent when client or opponent forfeits the game. <WBFR>,OriginatorCharacterName,TargetCharacterName
                                -- <WBBE> (Wowkemn battle: battle ended) Finalised end of battle message. sent by both clients. <WWBBE>,OriginatorCharacterName,TargetCharacterName,winner

                                function WowkemonSendChallengeRequest(targetPlayer)   -- Outgoing <WCR>
                                  if WowkemonAwaitingChallengeResponse == false and  WowkemonInBattle == false and WowkemonCurrentBattleOpponent == nil then
                                    local msg = "<WCR>,"..UnitName("Player")..","..UnitName("target")..","..WowkemonPlayerData["level"];
                                    WowkemonAwaitingChallengeResponse = true;
                                    sendWowkemonChannelMessage(msg)
                                    Wowkemon__wait(wowkemonChallengeTimeout,wowkemonResetBattleStatus,"NoResponse");
                                  else
                                    print("You are already challenging an opponent.");
                                  end
                                end

                                function WowkemonReceivedChallengeRequest(originPlayer,message)     -- Incoming <WCR>
                                  if WowkemonAwaitingChallengeResponse == false and WowkemonCurrentBattleOpponent == nil then
                                    print(originPlayer.." has challenged you.");
                                  --  print("you autoaccept") -- TEMPORARY REMOVE WHEN RESPONSE CHOICES ARE IMPLEMENTED
                                    WowkemonCurrentBattleOpponent = originPlayer;
                                  --  wowkemonRespondToChallenge(originPlayer,"accept") -- AUTOACCEPT
                                    wowkemonChallengeDialog(originPlayer)
                                  -- CREATE RESPONSE FRAME TO ACCEPT / DECLINE -- CALL WowkemonRespondToChallenge()
                                  else
                                    print("received request, auto declining")
                                    wowkemonRespondToChallenge(originPlayer,"decline")
                                end
                              end

                                function wowkemonRespondToChallenge(targetPlayer,response)     -- Outgoing <WCRA>
                                  local msg = "<WCRA>"
                                  if WowkemonInBattle == false then
                                  if response == "decline" then    -- Declined
                                    msg = "<WCRA>,"..UnitName("Player")..","..targetPlayer..",".."decline";
                                    WowkemonCurrentBattleOpponent = nil;
                                  elseif response =="accept" then  -- Accepted
                                    msg = "<WCRA>,"..UnitName("Player")..","..targetPlayer..",".."accept";
                                    WowkemonCurrentBattleOpponent = targetPlayer
                                    WowkemonInBattle = true;
                                      wowkemonLoadLobby()
                                  else -- Unknown response
                                      msg = "<WCRA>,"..UnitName("Player")..","..targetPlayer..",".."decline";
                                      WowkemonCurrentBattleOpponent = nil;
                                    print("error: attempting to send an unknown response to an incoming Wowkemon Battle Challenge. Declining.")
                                  end
                                  sendWowkemonChannelMessage(msg) -- Send response.
                                end
                              end

                                function wowkemonOpponentResponseToChallenge(targetPlayer,response)
                                  -- Incoming <WCRA>
                                  local result = string.find(response,"accept")
                                  if result ~= nil then
                                    WowkemonCurrentBattleOpponent = targetPlayer
                                    WowkemonInBattle = true
                                  --  print(targetPlayer.." has accepted your battle request!")
                                      wowkemonLoadLobby()
                                    -- Initialise battle
                                  else
                                    WowkemonCurrentBattleOpponent = nil;
                                    print(targetPlayer.." has declined your battle request!")
                                    wowkemonResetBattleStatus("clear")
                                end
                              end

                                function wowkemonBattleInitialOpponentDataReceived(origin,data)
                                -- Incoming <WBWI> (and WCI)
                                local a,b = string.find(data,"wCbO");
                                local c = string.find(data,",",b)
                                wowkemonOpponentWowkemonInfo[1] = string.sub(data,b+1,c-1);
                                a,b = string.find(data,"wKi")
                                c = string.find(data,",",b)
                                wowkemonOpponentWowkemonInfo[2] = string.sub(data,b+1,c-1)
                                a,b = string.find(data,"wLV")
                                c = string.find(data,",",b)
                                wowkemonOpponentWowkemonInfo[3] = string.sub(data,b+1,c-1);
                                a,b = string.find(data,"wKHP");
                                wowkemonOpponentWowkemonInfo[4] = tonumber(string.sub(data,b+1)) -- current HP
                                wowkemonOpponentWowkemonInfo[5] = string.sub(data,b+1) -- Max HP
                                wowkemonOpponentReady = true;
                              --  print("Recieved ready signal")
                                print("opponent is "..wowkemonOpponentWowkemonInfo[2]);

                                if wowkemonPlayerReady == true then -- Both players are aready!
                                wowkemonPrepareBattleFrames()
                                wowkemonBattleToggleActionFrames();
                                wowkemonUpdatePlayerAP(currentWowkemonAP);
                                wowkemonUpdatePlayerHP(currentWowkemonMaxHP)
                                end

                                end

                                function wowkemonBattleSendReadySignal(myWowkemon,wowkemonLevel,wowkemonHP)
                                  currentWowkemonAP = 0;
                                  -- wowkemonUpdateFeedbackText("",true)
                                  -- outgoing <WBWI> (and WCI)
                                  local msg = ""
                                  wowkemonPlayerReady = true
                                --  print("Sending ready signal");
                                  msg ="<WBWI>, wCbO"..WowkemonCurrentBattleOpponent..",wKi"..myWowkemon..",wLV"..wowkemonLevel..",wKHP"..wowkemonHP
                                  currentWowkemonHP = wowkemonHP
                                  sendWowkemonChannelMessage(msg)
                                  if wowkemonOpponentReady == true then -- both players are ready to Initiate the battle !
                                  wowkemonPrepareBattleFrames()
                                  currentWowkemonAP = 5;
                                  wowkemonUpdatePlayerAP(currentWowkemonAP);
                                  wowkemonUpdatePlayerHP(currentWowkemonMaxHP)
                                  end
                                end

                                function wowkemonPrepareBattleFrames() -- sets up the client side battle frames with all the relevant data.
                                  wowkemonLoadPvpFrame(wowkemonOpponentWowkemonInfo)
                                  print("loaded Battle!")
                                end

                                function wowkemonBattleBuildBattleMessage(attackName,baseDamage)
                                -- Outgoing <WBA>
                                if WowkemonSkills[attackName][4] <= currentWowkemonAP then
                                local msg;
                                msg = "<WBA>, wCbO"..WowkemonCurrentBattleOpponent..",AtN"..attackName..",BaDa"..baseDamage
                                sendWowkemonChannelMessage(msg);
                                wowkemonHideActionFrames();
                                wowkemonBattleToggleActionFrames();
                                currentWowkemonAP = currentWowkemonAP - WowkemonSkills[attackName][4];
                                wowkemonUpdatePlayerAP(currentWowkemonAP);
                                PlaySound(WowkemonSkills[attackName][5]);
                              else  -- Report fail. Not enough AP.
                                wowkemonUpdateFeedbackText("Not enough AP");
                                end
                              end

                                function wowkemonBattleActionReceived(targetPlayer,message)
                                  -- incoming <WBA>
                                  local a,b = string.find(message,"wCbO");
                                  local c = string.find(message,",",b);
                                  local rawDam = nil;
                                  a,b = string.find(message,"AtN");
                                  c = string.find(message,",",b);
                                  local incAttackName = string.sub(message,b+1,c-1)
                                  a,b = string.find(message,"BaDa");
                                  local rawDam = tonumber(string.sub(message,b+1));
                                  local damageType = "Normal"   -- whether the damage was resisted, normal or critical etc.
                                   -- Calculations should be done here vs resistance etc.
                                   currentWowkemonHP = currentWowkemonHP - rawDam
                                   local msg = "<WBAR>, wCbO"..WowkemonCurrentBattleOpponent..",DaT"..damageType..",ReHP"..currentWowkemonHP;
                                   wowkemonUpdatePlayerHP(currentWowkemonHP)
                                   wowkemonUpdateFeedbackText("You take "..rawDam.." damage from "..wowkemonOpponentWowkemonInfo[2].."'s "..incAttackName);
                                   wowkemonBattleSendAttackFeedback(msg)
                                   createPlayerAnimGroups();
                                   PlaySound(WowkemonSkills[incAttackName][5]);
                                   if currentWowkemonHP <= 0 then
                                     wowkemonSendBattleEnded(" dead")
                                   end


                                end

                                function wowkemonBattleUseBuff()
                                  -- Outgoing <WBBI>
                                end

                                function wowkemonBattleOpponentBuff()
                                  -- Incoming <WBBI>
                                end

                                function wowkemonBattleReceivedAttackFeedback(originPlayer,data)
                                -- Incoming <WBAR>
                                local a,b = string.find(data,"wCbO");
                                local c = string.find(data,",",b);
                                a,b = string.find(data,"DaT");
                                c = string.find(data,",",b);
                                local damType = string.sub(data,b+1,c-1);
                                a,b = string.find(data,"ReHP");
                                local oldHP = wowkemonOpponentWowkemonInfo[4]
                                wowkemonOpponentWowkemonInfo[4] = string.sub(data,b+1);
                                local totalDamage = oldHP - wowkemonOpponentWowkemonInfo[4];
                                wowkemonUpdateOpponentHP(wowkemonOpponentWowkemonInfo[4],wowkemonOpponentWowkemonInfo[5]);
                                wowkemonUpdateFeedbackText("You hit for "..totalDamage,true)
                                Wowkemon__wait(2,wowkemonUpdateFeedbackText,"Waiting for your opponent",true);
                                -- playSound(WowkemonSkills[incAttackName][5]);
                                createOpponentAnimGroups()
                                                                -- Update our local data
                                -- Any animation here
                                -- Show our Action frames.
                                end

                                function wowkemonBattleSendAttackFeedback(msg)-- Outgoing <WBAR>
                                  sendWowkemonChannelMessage(msg)
                                  wowkemonBattleToggleActionFrames("show");
                                  currentWowkemonAP = currentWowkemonAP + 5;
                                  wowkemonUpdatePlayerAP(currentWowkemonAP);


                                end

                                function wowkemonBattleSendForfeitNotice()
                                  print("you forfeit the match.")
                                  wowkemonHidePvpBattleFrames()
                                  if WowkemonCurrentBattleOpponent ~= nil then
                                  local msg = "<WBFR>,"..WowkemonCurrentBattleOpponent
                                  sendWowkemonChannelMessage(msg)
                                  wowkemonResetBattleStatus("clear")
                                end
                                -- Outgoing <WBFR>
                                end

                                function wowkemonBattleReceiveForfeitNotice()
                                  -- incoming <WBFR>
                                wowkemonResetBattleStatus("clear");
                                wowkemonHidePvpBattleFrames()
                                print("opponent forfeit the match.");
                                StopMusic();
                                end

                                function wowkemonReceivedBattleEnded(originPlayer,message)
                                  print("battle ended because opponent:"..message)
                                  wowkemonBattleToggleActionFrames();
                                  wowkemonResetBattleStatus("clear");
                                  Wowkemon__wait(2,wowkemonUpdateFeedbackText,"Battle ended "..message,true)
                                  StopMusic();
                                  -- Received <WBBE>

                                end

                                function wowkemonSendBattleEnded(reason)
                                  -- Send <WBBE>
                                  local msg = "<WBBE>,wCbO"..WowkemonCurrentBattleOpponent..",RsN"..reason;
                                  sendWowkemonChannelMessage(msg);
                                  wowkemonBattleToggleActionFrames()
                                  Wowkemon__wait(2,wowkemonUpdateFeedbackText,"Battle ended "..reason,true)
                                  wowkemonResetBattleStatus("clear");
                                  StopMusic()
                                end




function sendWowkemonChannelMessage(wowkemonMessage)
  local success = C_ChatInfo.SendAddonMessage(WowkemonChannelPrefix, wowkemonMessage, WowkemonChannelType)
  if success == true then
  --  print("Message sent");
  else
    print ("message failed to send");
  end
end

-- Channel monitor, listens for messages with the wowkemon prefix and assigns them appropriately.
wowkemonChannelMonitor = CreateFrame("Frame","wowkemonChannelMonitor",UIParent);
wowkemonChannelMonitor:SetSize(100,30);
wowkemonChannelMonitor:SetPoint("TOP");
wowkemonChannelMonitor:RegisterEvent("CHAT_MSG_ADDON");
wowkemonChannelMonitor:SetScript("OnEvent", function(self,event,arg1,arg2,arg3,arg4)
if event == "CHAT_MSG_ADDON" and arg1 == WowkemonChannelPrefix then --CHAT_MSG_ADDON: "prefix", "text", "channel", "sender", "target", zoneChannelID, localID, "name", instanceID

local msg = "";
local ns,ne = string.find(arg2,myCharacterName); -- was my character name found in the message? if so, its relevant to me.
  if ne ~= nil then
    ns = string.find(arg4,myCharacterName)
    if ns == nil then   -- Is the local player NOT the message sender
      local divideStart = 1;
      local divideEnd = string.find(arg2,",");
      local command = string.sub(arg2,divideStart,divideEnd-1);
      divideStart = divideEnd+1;
      wowkemonDispatchAppropriateBattleFunction(command,arg2,arg4)
    else -- is the local player the message sender.
    --  print("message from self");
    --  SendChatMessage(GetUnitName("player").." Message received from self.",WowkemonChannelType)
    end
  else
  end
-- local msg = arg1.." addon message from "..arg4;
 SendChatMessage(msg,WowkemonChannelType); -- Temporary confirmation
end

end)



function wowkemonDispatchAppropriateBattleFunction(command,message,originator)
  if command == "<WCR>" then
    WowkemonReceivedChallengeRequest(originator,message);
  elseif command == "<WCRA>" then
    wowkemonOpponentResponseToChallenge(originator,message);
  elseif command == "<WBWI>" then
    wowkemonBattleInitialOpponentDataReceived(originator,message);
  elseif command == "<WBBI>" then
    wowkemonBattleOpponentBuff(originator,message);
  elseif command == "<WBA>" then
    wowkemonBattleActionReceived(originator,message)
  elseif command == "<WBAR>" then
    wowkemonBattleReceivedAttackFeedback(originator,message);
  elseif command == "<WBFR>" then
    wowkemonBattleReceiveForfeitNotice(originator,message);
  elseif command == "<WBBE>" then
    wowkemonReceivedBattleEnded(originator,message);
end
end


function wowkemonChallengeDialog(target)
wowkemonChallengeFrame = CreateFrame("Frame","WowkemonChallengeFrame",UIParent)
wowkemonChallengeFrame:SetBackdrop(CaptureFrameBackdrop)
wowkemonChallengeFrame:SetSize(400,150)
wowkemonChallengeFrame:SetPoint("CENTER",UIParent,"CENTER")
wowkemonChallengeFrame.textContent = wowkemonChallengeFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
wowkemonChallengeFrame.textContent:SetText(target.."\nhas challenged you to a Wowkemon Battle!")
wowkemonChallengeFrame.textContent:SetPoint("TOP",wowkemonChallengeFrame,0,-10)
wowkemonChallengeFrame.Accept = CreateFrame("Button","WowkemonChallengeAcceptBtn",wowkemonChallengeFrame,"UIPanelButtonTemplate")
wowkemonChallengeFrame.Accept:SetText("Accept")
wowkemonChallengeFrame.Accept:SetPoint("LEFT",wowkemonChallengeFrame,"LEFT",15,0);
wowkemonChallengeFrame.Accept:SetScript("OnClick", function() wowkemonRespondToChallenge(target,"accept") wowkemonChallengeFrame:Hide() end)

wowkemonChallengeFrame.Decline = CreateFrame("button","wowkemonChallengeDeclineBtn",wowkemonChallengeFrame,"UIPanelButtonTemplate")
wowkemonChallengeFrame.Decline:SetText("Decline")
wowkemonChallengeFrame.Decline:SetPoint("RIGHT",wowkemonChallengeFrame,"RIGHT",-50,0)
wowkemonChallengeFrame.Decline:SetScript("OnClick", function() wowkemonRespondToChallenge(target,"decline") wowkemonResetBattleStatus() wowkemonChallengeFrame:Hide() end)
  Wowkemon__wait(wowkemonChallengeTimeout-2,forceHidewowkemonChallengePanel)
  Wowkemon__wait(wowkemonChallengeTimeout,wowkemonRespondToChallenge,target,"decline");
end

function forceHidewowkemonChallengePanel()
  wowkemonChallengeFrame:Hide();
end
